Subject: Classless Static Routes option, final discussion (I hope)!

From: Ted Lemon <[email-masked]>
Date: Mon, 19 Jun 2000 12:48:15 -0700

I've just submitted what I hope will be the final version of the
classless static routes option.   I clarified some text about how the
client must behave - it was sufficiently ambiguous that I think there
was room for non-interoperating implementations, unfortunately.   I
also fixed an example so that it made sense given the more compact
encoding - it wasn't actually possible to encode the previous
example.   :'}   Diffs are included below, FYA.

There is one remaining bug that I just noticed - I said "should" twice
in the last significant diff when I should have said "SHOULD" and
"[should] not" when I should have said "SHOULD NOT".   If it's
acceptable to the group, I can fix these when the IANA issues us an
option code.

			       _MelloN_

*** draft-ietf-dhc-csr-01.txt	Wed Mar 15 10:48:05 2000
--- draft-ietf-dhc-csr-02.txt	Mon Jun 19 11:48:41 2000
***************
*** 2,13 ****
  Network Working Group                                            Ted Lemon
  Internet Draft						      Nominum, Inc.
  
! Obsoletes: draft-ietf-dhc-csr-00.txt			       March, 2000
!                                                     Expires September 2000

  	      The Classless Static Route Option for DHCP
! 		     <draft-ietf-dhc-csr-01.txt>
  
  Status of this Memo
  
--- 2,13 ----
  Network Working Group                                            Ted Lemon
  Internet Draft						      Nominum, Inc.
  
! Obsoletes: draft-ietf-dhc-csr-01.txt			        June, 2000
!                                                       Expires January 2001

  	      The Classless Static Route Option for DHCP
! 		     <draft-ietf-dhc-csr-02.txt>
  
  Status of this Memo
  
***************
*** 162,172 ****
  
  DHCP Client Behavior
  
!    The DHCP client MAY use this option to install a set of static
!    routes in its routing table.   A DHCP client that implements this
!    option SHOULD use this option in preference to the Static routes
!    option if both are present in a reply from the DHCP server.   The
!    client MAY request both options.
  
     After deriving a subnet number and subnet mask from each
     destination descriptor, the DHCP client SHOULD check each route to
--- 162,179 ----
  
  DHCP Client Behavior
  
!    DHCP clients that do not support this option MUST ignore it if it
!    is received from a DHCP server.   DHCP clients that support this
!    option MUST install the routes specified in the option.
! 
!    DHCP clients that support this option and that send a DHCP
!    Parameter Request List option MUST request both this option and
!    the Routers option [2] in the DHCP Parameter Request List.
! 
!    If the DHCP server returns a Routers option, clients that support
!    the Classless Static Routes option MUST use the default route(s)
!    listed in the Routers option in addition to the routes listed
!    in the Classless Static Routes option.
  
     After deriving a subnet number and subnet mask from each
     destination descriptor, the DHCP client SHOULD check each route to
***************
*** 174,180 ****
     value is one whose corresponding value in the subnet mask is zero,
     and SHOULD NOT install any routes for which this is the case.  For
     example, the client should not install a route with a destination
!    of 129.210.377.4 and a subnet mask of 255.255.255.0.
  
     Because a full routing table can be quite large, the standard 576
     octet maximum size for a DHCP message may be too short to contain
--- 181,187 ----
     value is one whose corresponding value in the subnet mask is zero,
     and SHOULD NOT install any routes for which this is the case.  For
     example, the client should not install a route with a destination
!    of 129.210.377.4 and a subnet mask of 255.255.255.128.
  
     Because a full routing table can be quite large, the standard 576
     octet maximum size for a DHCP message may be too short to contain
***************
*** 187,209 ****
  
  DHCP Server administrator responsibilities
  
!    The client's behaviour if both a Routers option and a Classless
!    Static Routes option default route (network number 0.0.0.0, network
!    mask 0.0.0.0) are specified is not defined in this document, so as
!    to avoid placing onerous requirements on the client and server
!    implementations.   Therefore, the DHCP server administrator SHOULD
!    NOT configure the DHCP server so that it sends both a Routers
!    option and a Classless Static Routes option containing a default
!    route.   Either no Routers option should be configured (this is
!    probably preferable in the near term, since only newer DHCP clients
!    will implement this option), or the Classless Static Routes option
!    should not contain a default route.
! 
!    The client's behaviour is also not defined in the case where the
!    server sends a classless static route in which some bits in the
!    network number are 1, and corresponding bits in the subnet mask are
!    zero.   Therefore, DHCP server administrators SHOULD NOT configure
!    the DHCP server to send such a route.
  
  Security Considerations
  
--- 194,205 ----
  
  DHCP Server administrator responsibilities
  
!    Many clients may not implement the Classless Static Routes option.
!    DHCP server administrators should therefore configure their DHCP
!    servers to send both a Routers option and a Classless Static
!    Routes option, and should specify all default routes in the Routers
!    option, and not specify any default routes in the Classless
!    Static Routes option.
  
  Security Considerations
  
***************
*** 247,253 ****
  
  Expiration
  
!    This document will expire on July 31, 2000.
  
  Full Copyright Statement
  
--- 243,249 ----
  
  Expiration
  
!    This document will expire on January 31, 2001.
  
  Full Copyright Statement